function OnSceneLoad(screen)
    LoadData(screen)
    DefaultOnSceneLoad('data/Scenes/15_Workshop_Cupboard_HO.lua', 'hidden_object', 'data/Scenes/15_Workshop_Main.lua')
    
    AddTask( CreateTask('SCREWDRIVER', '',                 'Screwdriver'));
    AddTask( CreateTask('BOTTLE',      'BOTTLES',          'Bottle1',      'Bottle2', 'Bottle3'));
    --AddTask( CreateTask('BOOT',        'BOOTS',            'Boot1',        'Boot2'));             -- EAP-651
    AddTask( CreateTask('LOCK',        'LOCKS',            'Lock1',        'Lock2'));
    AddTask( CreateTask('TOBACCO_PIPE','TOBACCO_PIPES',    'TobaccoPipe1', 'TobaccoPipe2'));
    
    AddRandomTasks( CreateTask('BAG',              '', 'Bag'),
                    CreateTask('BINOCULAR',        '', 'Binocular'),
                    --CreateTask('BOOK',             '', 'Book'),           -- EAP-695
                    CreateTask('BUTTERFLY',        '', 'Butterfly'),
                    CreateTask('CANDLESTICK',      '', 'Candlestick'),
                    CreateTask('COFFEE_GRINDER',   '', 'CoffeeGrinder'),
                    CreateTask('FLY',              '', 'Fly'),
                    CreateTask('GLASS',            '', 'Glass'),
                    CreateTask('HAMMER',           '', 'Hammer'),
                    --CreateTask('LAMP',             '', 'Lamp'),           -- EAP-417
                    CreateTask('PEAR',             '', 'Pear'),
                    CreateTask('PEPPER',           '', 'Pepper'),
                    CreateTask('POCKET_WATCH',     '', 'PocketWatch'),
                    --CreateTask('RAG',              '', 'Rag'),            -- EAP-696
                    --CreateTask('ROPE',             '', 'Rope'),           -- EAP-418
                    CreateTask('SNAIL',            '', 'Snail'),
                    CreateTask('STICKERS',         '', 'Stickers'),
                    CreateTask('TOBACCO_POUCH',    '', 'TobaccoPouch'),
                    CreateTask('HAND_PLANE',       '', 'HandPlane'),
                    CreateTask('BRANCH',           '', 'Willow'));
    
    RegisterToolFindInfo('15_screwdriver');
end

function OnSceneFree(screen)
    DefaultOnSceneFree()
    FreeData(screen)
end

function OnUpdate(dt)
    DefaultOnUpdate(dt)
end

function OnAllItemsFound()
    DefaultOnAllItemsFound()
end

function OnLose()
    DefaultOnLose()
end

function OnExit()
    DefaultOnExit()
end

function OnClose()
    DefaultOnClose()
end

function OnObjectMouseEnter(object)
    DefaultOnObjectMouseEnter(object)
end

function OnObjectMouseLeave(object)
    DefaultOnObjectMouseLeave(object)
end

function OnObjectMouseDown(object)
    local is_wrong_click = not DefaultOnObjectMouseDown(object)
    local obj_name = object:GetName()
    local pf = play_field

    DefaultOnObjectMouseDownProcessed(is_wrong_click);
end

function OnObjectMouseUp(object)
    DefaultOnObjectMouseUp(object)
end

function OnObjectFound(object)
    DefaultOnObjectFound(object)
end

function OnToolFound(tool)
    DefaultOnToolFound(tool)
end

function OnToolApply(tool, object)
    DefaultOnToolApply(tool, object)
end

function OnObjectReachPanel(object)
    DefaultOnObjectReachPanel(object)
end

function OnButtonPress(title)
    DefaultOnButtonPress(title)
end

function OnMouseMove(previous_pos, current_pos)
    DefaultOnMouseMove(previous_pos, current_pos)
end

function OnSetTool(tool)
    DefaultOnSetTool(tool)
end

function LevelLoaded(level)
end

function OnSceneDestroy(playfield)
    DefaultOnSceneDestroy(playfield)
end

--------------------------------------------------------------------------------
-- CLEAR_ON_SAVE_BEGIN
-- Do not edit code listed below (generated by the editor on each save)
function LoadData(screen)
	local anim = CreateAnimation('data/Texture/Scenes/15_Workshop/Zone_HO_cupboard/Layers/background.jpg',0,0,1024,768,1,0)
	anim:SetHotSpot(512,384)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('background',anim,512,384,100,0,1,1)
	local anim = CreateAnimation('data/Texture/Scenes/15_Workshop/Zone_HO_cupboard/Items/Bag.png',0,0,132,126,1,0)
	anim:SetHotSpot(66,63)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('Bag',anim,807,498,102,0,1,1)
	local anim = CreateAnimation('data/Texture/Scenes/15_Workshop/Zone_HO_cupboard/Items/Binocular.png',0,0,97,52,1,0)
	anim:SetHotSpot(48,26)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('Binocular',anim,684,436,101,0,1,1)
	local anim = CreateAnimation('data/Texture/Scenes/15_Workshop/Zone_HO_cupboard/Items/Book.png',0,0,128,68,1,0)
	anim:SetHotSpot(64,34)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('Book',anim,616,582,101,0,1,1)
	local anim = CreateAnimation('data/Texture/Scenes/15_Workshop/Zone_HO_cupboard/Items/Boot1.png',0,0,98,104,1,0)
	anim:SetHotSpot(49,52)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('Boot1',anim,675,289,101,0,1,1)
	local anim = CreateAnimation('data/Texture/Scenes/15_Workshop/Zone_HO_cupboard/Items/Boot2.png',0,0,76,102,1,0)
	anim:SetHotSpot(38,51)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('Boot2',anim,856,485,101,0,1,1)
	local anim = CreateAnimation('data/Texture/Scenes/15_Workshop/Zone_HO_cupboard/Items/Bottle1.png',0,0,58,120,1,0)
	anim:SetHotSpot(29,60)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('Bottle1',anim,579,266,101,0,1,1)
	local anim = CreateAnimation('data/Texture/Scenes/15_Workshop/Zone_HO_cupboard/Items/Bottle2.png',0,0,58,128,1,0)
	anim:SetHotSpot(29,64)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('Bottle2',anim,447,459,101,0,1,1)
	local anim = CreateAnimation('data/Texture/Scenes/15_Workshop/Zone_HO_cupboard/Items/Bottle3.png',0,0,105,49,1,0)
	anim:SetHotSpot(52,24)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('Bottle3',anim,522,55,101,0,1,1)
	local anim = CreateAnimation('data/Texture/Scenes/15_Workshop/Zone_HO_cupboard/Items/Butterfly.png',0,0,74,89,1,0)
	anim:SetHotSpot(37,44)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('Butterfly',anim,35,588,101,0,1,1)
	local anim = CreateAnimation('data/Texture/Scenes/15_Workshop/Zone_HO_cupboard/Items/Candlestick.png',0,0,46,120,1,0)
	anim:SetHotSpot(23,60)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('Candlestick',anim,634,411,101,0,1,1)
	local anim = CreateAnimation('data/Texture/Scenes/15_Workshop/Zone_HO_cupboard/Items/CoffeeGrinder.png',0,0,107,101,1,0)
	anim:SetHotSpot(53,50)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('CoffeeGrinder',anim,250,549,101,0,1,1)
	local anim = CreateAnimation('data/Texture/Scenes/15_Workshop/Zone_HO_cupboard/Items/Fly.png',0,0,44,29,1,0)
	anim:SetHotSpot(22,14)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('Fly',anim,726,464,101,0,1,1)
	local anim = CreateAnimation('data/Texture/Scenes/15_Workshop/Zone_HO_cupboard/Items/Glass.png',0,0,62,96,1,0)
	anim:SetHotSpot(31,48)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('Glass',anim,446,298,101,0,1,1)
	local anim = CreateAnimation('data/Texture/Scenes/15_Workshop/Zone_HO_cupboard/Items/Lock1.png',0,0,76,70,1,0)
	anim:SetHotSpot(38,35)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('Lock1',anim,828,563,103,0,1,1)
	local anim = CreateAnimation('data/Texture/Scenes/15_Workshop/Zone_HO_cupboard/Items/Lock2.png',0,0,67,64,1,0)
	anim:SetHotSpot(33,32)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('Lock2',anim,231,314,101,0,1,1)
	local anim = CreateAnimation('data/Texture/Scenes/15_Workshop/Zone_HO_cupboard/Items/Pear.png',0,0,46,50,1,0)
	anim:SetHotSpot(23,25)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('Pear',anim,509,437,101,0,1,1)
	local anim = CreateAnimation('data/Texture/Scenes/15_Workshop/Zone_HO_cupboard/Items/PocketWatch.png',0,0,47,40,1,0)
	anim:SetHotSpot(23,20)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('PocketWatch',anim,212,580,102,0,1,1)
	local anim = CreateAnimation('data/Texture/Scenes/15_Workshop/Zone_HO_cupboard/Items/Rag.png',0,0,63,176,1,0)
	anim:SetHotSpot(31,88)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('Rag',anim,810,340,101,0,1,1)
	local anim = CreateAnimation('data/Texture/Scenes/15_Workshop/Zone_HO_cupboard/Items/Snail.png',0,0,35,59,1,0)
	anim:SetHotSpot(17,29)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('Snail',anim,891,310,101,0,1,1)
	local anim = CreateAnimation('data/Texture/Scenes/15_Workshop/Zone_HO_cupboard/Items/Stickers.png',0,0,106,121,1,0)
	anim:SetHotSpot(53,60)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('Stickers',anim,323,216,101,0,1,1)
	local anim = CreateAnimation('data/Texture/Scenes/15_Workshop/Zone_HO_cupboard/Items/TobaccoPipe1.png',0,0,46,98,1,0)
	anim:SetHotSpot(23,49)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('TobaccoPipe1',anim,667,505,101,0,1,1)
	local anim = CreateAnimation('data/Texture/Scenes/15_Workshop/Zone_HO_cupboard/Items/TobaccoPipe2.png',0,0,85,35,1,0)
	anim:SetHotSpot(42,17)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('TobaccoPipe2',anim,678,152,103,7,1,1)
	local anim = CreateAnimation('data/Texture/Scenes/15_Workshop/Zone_HO_cupboard/Items/Willow.png',0,0,126,200,1,0)
	anim:SetHotSpot(63,100)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('Willow',anim,768,175,103,0,1,1)
	local anim = CreateAnimation('data/Texture/Scenes/15_Workshop/Zone_HO_cupboard/Layers/ol_kruchek.png',0,0,13,18,1,0)
	anim:SetHotSpot(6,9)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('ol_kruchek',anim,243,286,102,0,1,1)
	local anim = CreateAnimation('data/Texture/Scenes/15_Workshop/Zone_HO_cupboard/Layers/ol_platok.png',0,0,67,102,1,0)
	anim:SetHotSpot(33,51)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('ol_platok',anim,269,327,102,0,1,1)
	local anim = CreateAnimation('data/Texture/Scenes/15_Workshop/Zone_HO_cupboard/Layers/ol_miska.png',0,0,140,119,1,0)
	anim:SetHotSpot(70,59)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('ol_miska',anim,521,461,102,0,1,1)
	local anim = CreateAnimation('data/Texture/Scenes/05_Gendarmery/Zone_wart/Animations/fly_anim.png',0,0,217,217,8,12)
	anim:SetHotSpot(108,108)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('fly_anim_1',anim,981,217,103,0,1.2,1.2)
	local anim = CreateAnimation('data/Texture/Scenes/05_Gendarmery/Zone_wart/Animations/fly_anim.png',0,0,217,217,8,9)
	anim:SetHotSpot(108,108)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('fly_anim_2',anim,1,214,103,0,1.2,1.2)
	local anim = CreateAnimation('data/Texture/Scenes/Common/Animations/candle.png',0,0,20,40,25,18)
	anim:SetHotSpot(10,20)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('candle_flame2',anim,982,212,102,0,1.4,1.4)
	local anim = CreateAnimation('data/Texture/Scenes/15_Workshop/Zone_HO_cupboard/Items/Screwdriver.png',0,0,100,31,1,0)
	anim:SetHotSpot(50,15)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('Screwdriver',anim,303,54,101,0,1,1)
	local anim = CreateAnimation('data/Texture/Scenes/15_Workshop/Zone_HO_cupboard/Items/HandPlane.png',0,0,94,85,1,0)
	anim:SetHotSpot(47,42)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('HandPlane',anim,606,513,101,0,1,1)
	local anim = CreateAnimation('data/Texture/Scenes/15_Workshop/Zone_HO_cupboard/Items/TobaccoPouch.png',0,0,51,107,1,0)
	anim:SetHotSpot(25,53)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('TobaccoPouch',anim,325,358,101,0,1,1)
	local anim = CreateAnimation('data/Texture/Scenes/15_Workshop/Zone_HO_cupboard/Layers/BG_Kiset.png',0,0,18,15,1,0)
	anim:SetHotSpot(9,7)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('BG_Kiset',anim,320,312,102,0,1,1)
	local anim = CreateAnimation('data/Texture/Scenes/15_Workshop/Zone_HO_cupboard/Items/Hammer.png',0,0,102,107,1,0)
	anim:SetHotSpot(51,53)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('Hammer',anim,517,534,101,0,1,1)
	local anim = CreateAnimation('data/Texture/Scenes/15_Workshop/Zone_HO_cupboard/Items/Pepper.png',0,0,53,49,1,0)
	anim:SetHotSpot(26,24)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('Pepper',anim,925,51,101,0,1,1)
	local anim = CreateAnimation('data/Texture/Scenes/15_Workshop/Zone_HO_cupboard/Layers/BG_Bottle3.png',0,0,102,42,1,0)
	anim:SetHotSpot(51,21)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('BG_Bottle3',anim,509,72,102,0,1,1)
	local anim = CreateAnimation('data/Texture/Scenes/15_Workshop/Zone_HO_cupboard/Layers/BG_Pepper.png',0,0,79,37,1,0)
	anim:SetHotSpot(39,18)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('BG_Pepper',anim,928,63,102,0,1,1)
end

function FreeData(screen)
end
-- CLEAR_ON_SAVE_END
